#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/telnet.h>
#include <netdb.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <termio.h>
#include <utime.h>
#include <unistd.h>

#include "config.h"
#include "version.h"

#define CRCSIZE 512

struct termio stty0;

struct regresadir {
  char name[1024], link[1024];
  int tipo,n;
  int umode,gmode,wmode;
  int anio,mes,dia,hora,min;
  unsigned long size;
  time_t tdate;
};

int checkgzip();
void sttybbs(int);
int inkey();
unsigned long dir_INET(char *); 
int abreconexion(char *); 
int bajaarchivos(int, char *); 
char *getline(int, char *); 
char *getlinels(int, char *); 
int putline(int, char *);
int erasefile(char *, int);
struct regresadir **leedir(int);
int grabaarch(int, char *, unsigned long, struct regresadir);
int loginftp(int);
int sendportcmd(int, int, unsigned long);
int cambiadir(int, char *);
char *dimedir(int);
char *aprox(unsigned long, unsigned long, unsigned long, time_t);
void iniciaftp(char **);
int checkr(int);
int checkw(int);
int waitfordata(int, int);
int waitforsend(int, int);
int checkexclude(char *);
int checkdownload(char *);
struct regresadir *checkmdtm(struct regresadir *, int);
int EsElMismo(char *, int);
long fnGetBandWidth();

int dirs=0, ddirs=0, archs=0, darchs=0;
long priority=100, priochg=0, bandwidth;

char **gargv;
char srcpath[1024];
char myhostidname[256];
unsigned long myhostid;

time_t filetime;
char filename[256];
FILE *filehand;

char **exclude=NULL, **download=NULL;
int maxexclude=0, maxdownload=0;

int gzip=1, compressed=0, ignoredate=0, ignoresize=0, mirror=0, ERASEFILES=0;

char USUARIO[256]={"anonymous"}, PASSWORD[256]={"autoftp"};

/* Recibe direccion, directorio */
int main(int argc, char *argv[])
{
  int i;
  printf("AutoFTP v%s Mario Medina Software, 1988-99\n",VERSION);
  sprintf(PASSWORD,"%s@%s",getenv("USER"),getenv("HOSTNAME"));
  getcwd(srcpath,1024);
  if(argc>1)
    if(!strcmp(argv[1],"-help")) {
      printf("autoftp <direccion> <directorio>  Baja archivos de la direccion\n");
      printf("autoftp -help                     Muestra esta ayuda\n");
      printf("autoftp -ignoredate               Ignora cambios de fecha, solo transfiere\n");
      printf("                                 archivos de tamao diferente o no existentes\n");
      printf("autoftp -ignoresize               Ignora el tamao en caso de que se use\n");
      printf("                                 ignoredate evita que se borre el archivo si es\n");
      printf("                                 de tamaos diferentes\n");
      printf("autoftp -x dir1 dir2 arch1        No baja los directorios especificados\n");
      printf("autoftp -i dir1 dir2 arch1        Baja solo los directorios especificados\n");
      printf("autoftp -u<usuario>               Utiliza un usuario y password diferentes de\n");
      printf("autoftp -p<password>             anonymous y la direccion de e-mail\n");
      printf("autoftp -nogzip                   Desactiva la compresion de archivos\n");
      printf("autoftp -n<0-100>                 Modifica los recursos de red usados\n"
             "                                 (100%% default)\n");
      printf("autoftp -mirror                   Carga AutoFTP para hacer un espejo de algun\n"
             "                                 sitio en la maquina en la que corre. Este modo\n"
             "                                 envia toda la salida a el archivo .AutoFTP\n"
             "                                 haciendo el proceso mas silencioso, ademas se\n"
             "                                 carga como daemon\n");
      printf("autoftp -delete                   Elimina cada archivo del directorio origen\n"
             "                                 despues de bajarlo completamente\n");
      exit(0);
    }
  if(argc<3) {
    printf("Falto indicar la direccion y el directorio origen\n");
    printf("-help para ayuda\n");
    exit(1);
  }
  for(i=1;i<argc;i++) {
    if(!strcmp(argv[i],"-ignoredate")) ignoredate=1; else
    if(!strcmp(argv[i],"-ignoresize")) ignoresize=1; else
    if(!strcmp(argv[i],"-nogzip")) gzip=0; else
    if(!strcmp(argv[i],"-mirror")) mirror=1; else
    if(!strcmp(argv[i],"-delete")) ERASEFILES=1; else
    if(!strncmp(argv[i],"-u",2)) strcpy(USUARIO,(char *)&argv[i][2]); else
    if(!strncmp(argv[i],"-n",2)) {
      priority=atol((char *)&argv[i][2]);
      if(priority<=0) priority=1;
      if(priority>100) priority=100;
    } else
    if(!strncmp(argv[i],"-p",2)) {
      if(strlen(argv[i])==2) {
        printf("Dame el password de la cuenta (enter sin password): ");
        strcpy(PASSWORD,(char *)getpass(""));
      } else {
        strcpy(PASSWORD,(char *)&argv[i][2]);
      }
    } else
    if(!strcmp(argv[i],"-x")) {
      int f=0;
      exclude=(char **)malloc((f+5)*sizeof(char *));
      maxexclude=f;
      for(i++;i<argc;i++) {
        if(!strcmp(argv[i],"-x")          || !strcmp(argv[i],"-help") ||
           !strcmp(argv[i],"-ignoredate") || !strncmp(argv[i],"-u",2) ||
           !strncmp(argv[i],"-p",2)       || !strncmp(argv[i],"-n",2) ||
           !strcmp(argv[i],"-mirror")     || !strcmp(argv[i],"-ignoresize") ||
           !strcmp(argv[i],"-i")          || !strcmp(argv[i],"-nogzip")) {
             i--;
             maxexclude=f;
             break;
        }
        exclude=(void *)realloc(exclude,(f+5)*sizeof(void *));
        exclude[f]=(char *)malloc(strlen(argv[i])+5);
        strcpy(exclude[f],argv[i]);
        printf("exclude: {%s}\n",exclude[f]);
        exclude[++f]=NULL;
        maxexclude=f;
      }
    } else
    if(!strcmp(argv[i],"-i")) {
      int f=0;
      download=(char **)malloc((f+5)*sizeof(char *));
      maxdownload=f;
      for(i++;i<argc;i++) {
        if(!strcmp(argv[i],"-x")          || !strcmp(argv[i],"-help") ||
           !strcmp(argv[i],"-ignoredate") || !strncmp(argv[i],"-u",2) ||
           !strncmp(argv[i],"-p",2)       || !strncmp(argv[i],"-n",2) ||
           !strcmp(argv[i],"-mirror")     || !strcmp(argv[i],"-ignoresize") ||
           !strcmp(argv[i],"-i")          || !strcmp(argv[i],"-nogzip")) {
             i--;
             maxdownload=f;
             break;
        }
        download=(void *)realloc(download,(f+5)*sizeof(void *));
        download[f]=(char *)malloc(strlen(argv[i])+5);
        strcpy(download[f],argv[i]);
        printf("download: {%s}\n",download[f]);  
        download[++f]=NULL;
        maxdownload=f;
      }
    }
  }
  gargv=argv;
  if(gzip==1) checkgzip();
  bandwidth=fnGetBandWidth();
  printf("Enlace de %u %sbytes\n",(bandwidth>8192)?(bandwidth/1024):bandwidth,
                             (bandwidth>8192)?"k":"");
  if(mirror) {
    int i,s;
    if((i=fork())) {
      waitpid(i,&s,0);
      exit(0);
    }
    if(fork()) exit(0);
  }
  iniciaftp(gargv);
}


void interrupcion(void)
{
  struct utimbuf ut;
  char tmpfile[300],tmpcmd[400];
  fclose(filehand);
  if(compressed==1&&(gzip==1||gzip==2)) {
    sprintf(tmpfile,"%s.gz",filename);
    printf("No se puede continuar un archivo comprimido... descomprimiendo\n");
    if(unlink(tmpfile)==-1) printf("No pude borrar temporal comprimido\n");
    rename(filename,tmpfile);
    sprintf(tmpcmd,"gzip -d -c \x22%s\x22 > \x22%s\x22",tmpfile,filename);
    system(tmpcmd);
    if(unlink(tmpfile)==-1) printf("No pude borrar temporal comprimido\n");
  }
  ut.actime=ut.modtime=filetime;
  utime(filename,&ut);
  printf("\nPrograma terminado por interrupcion\n");
  exit(0);
}

void interrupcionC(void)
{
  struct utimbuf ut;
  char tmpfile[300],tmpcmd[400];
  char resp[256];
  fflush(stdin);
  printf("Estas seguro de querer cancelar? teclea 's' para salir o la nueva prioridad: ");
  scanf("%s",resp);
  if(tolower(resp[0])!='s') {
    if(atoi(resp)<=0) priority=1; else 
    if(atoi(resp)>100) priority=100; else
    priority=atoi(resp);
    priochg=1;
    return;
  }
  interrupcion();
}

void iniciaftp(char *argv[])
{
  int sock;
  int loops=0;
  if(mirror) {
    freopen(".AutoFTP","wt",stdout);
    freopen(".AutoFTP","at",stderr);
inittry:;
    printf("AutoFTP v%s Mario Medina Software, 1988-99\n",VERSION);
  }
  do {
    chdir(srcpath);
    loops=0;
    sock=abreconexion(argv[1]);
    if(sock<=0) {
      printf("Error abriendo conexion\n");
      exit(2);
    }
    if(!loginftp(sock)) {
      if(bajaarchivos(sock,argv[2])==2) loops=1;
    } else {
      loops=1;
    }
  } while(loops);
  printf("%u directorios, %u creados\n",dirs,ddirs);
  printf("%u archivos, %u bajados\n",archs,darchs);
  printf("Archivos transferidos correctamente\n");
  if(mirror) {
    time_t t=time(NULL);
    dirs=ddirs=archs=darchs=0;
    printf("AutoFTP termino espejo en %s",ctime(&t));
    goto inittry;
  }
  exit(0);
}
 
int abreconexion(char *addr) 
{
  int sd,socklen;
  struct sockaddr_in sockname;
reconect:;  
  if((sd=socket(AF_INET, SOCK_STREAM, 0))==-1)
    perror("Cliente:Socket"), exit(1);
  sockname.sin_family=AF_INET;
  sockname.sin_addr.s_addr=dir_INET(addr);
  sockname.sin_port=htons(21);
  printf("Conectandome...");          
  fflush(stdout);
  if(connect(sd,(struct sockaddr *)&sockname, sizeof(sockname))==-1) {
    perror("Cliente:Connect");
    sleep(5);
    goto reconect;
  }
  sleep(3);
  printf("conectado\n");  
  socklen=sizeof(sockname);
  if(getsockname(sd,(struct sockaddr *)&sockname,&socklen)<0) 
    perror("GETSOCKNAME"), exit(1);
  strcpy(myhostidname,(char *)inet_ntoa(sockname.sin_addr));
  myhostid=dir_INET(myhostidname);
  return sd;                    
}

int bajaarchivos(int sock, char *path)
{
  char *buffer=NULL;
  char tmpbuf[1024];
  int i;
  struct regresadir **rd;
  struct utimbuf ut;
  if(cambiadir(sock,path)) return 0;
  rd=leedir(sock);
  if(rd==NULL) return 2;
  for(i=0;i<rd[0]->n;i++) {
    fflush(stdout);
    switch(rd[i]->tipo) {
      case '-':
        if(checkexclude(rd[i]->name)) {
          printf("No bajo archivo [%s]\n",rd[i]->name);
          break; 
        }
        if((maxdownload>0&&checkdownload(rd[i]->name)==1) ||
           maxdownload<=0) { 
          
          printf("Bajando archivo [%s] ",rd[i]->name); fflush(stdout);
          rd[i]=checkmdtm(rd[i],sock);
#ifdef DEBUG
          printf("checkr reporto %d\n",checkr(sock));
#endif
          switch(grabaarch(sock,rd[i]->name,rd[i]->size,*rd[i])) {
            case 0: 
               darchs++; 
               if(ERASEFILES) erasefile(rd[i]->name,sock);
               break;
            case 15:
               break;
            case 10: return 2;
          }
          chmod(rd[i]->name,rd[i]->umode|rd[i]->gmode|rd[i]->wmode);
          ut.actime=ut.modtime=rd[i]->tdate;
          utime(rd[i]->name,&ut);
          archs++;
        }
        break;
      case 'l':
        if(checkexclude(rd[i]->name)) {
          printf("No creo liga [%s -> %s]\n",rd[i]->name,rd[i]->link); fflush(stdout);
          break; 
        }
        printf("Creando liga [%s -> %s] ",rd[i]->name,rd[i]->link); fflush(stdout);
        if(symlink(rd[i]->link,rd[i]->name)==-1) {
          printf("x\n");
        } else printf("v\n");
        break;
      case 'd':
        if(checkexclude(rd[i]->name)) {
          printf("No bajo directorio [%s]\n",rd[i]->name); fflush(stdout);
          break; 
        }
        if(strcmp(rd[i]->name,"..")&&strcmp(rd[i]->name,".")) {
          if(!strcmp(rd[i]->name,".")) printf("si es....\n\n");
          printf("Cambiando al directorio [%s]\n",rd[i]->name); fflush(stdout);
          if(!strcmp(rd[i]->name,"save")) getchar();
          dirs++;
          if(mkdir(rd[i]->name,S_IRWXU)!=-1) ddirs++;
          chmod(rd[i]->name,rd[i]->umode|rd[i]->gmode|rd[i]->wmode);
          ut.actime=ut.modtime=rd[i]->tdate;
          utime(rd[i]->name,&ut);
          chdir(rd[i]->name);
          switch(bajaarchivos(sock,rd[i]->name)) {
            case 1: 
              if(cambiadir(sock,"..")) return 2; 
              break;
            case 2:
              chdir("..");
              utime(rd[i]->name,&ut);
              return 2;
          }
          chdir("..");
          utime(rd[i]->name,&ut);
        }
        break;
    }
  }
  return 1;
}

struct regresadir **leedir(int sock)
{
  int sd,sdr,l,i;
  struct sockaddr_in server;
  fd_set listo;
#if TIMEVALORSPEC == 2
  struct timespec tout;
#else
  struct timeval tout;
#endif  
  char *buffer=NULL;
  struct regresadir **rd=NULL;
  char datos[9][256];
  char tmpdat[512];
  unsigned long tfiles=0;
  
resock:;
  sd=socket(AF_INET,SOCK_STREAM,0);
  server.sin_family=AF_INET;
  server.sin_addr.s_addr=INADDR_ANY;
rebind:;
  srand(time(NULL)*rand());
  {
    unsigned int i=rand();
    while(i<1024||i>60000) i=rand();
    server.sin_port=htons(i);
  }
  if(bind(sd,(struct sockaddr *)&server, sizeof(server))) {
    perror("BIND");
    goto rebind;
  }
  l=sizeof(server);
  getsockname(sd,(struct sockaddr *)&server,&l);
  if(!mirror) printf("Esperando en puerto %u para comando LIST\n",ntohs(server.sin_port));
  listen(sd,1);
  if(sendportcmd(sock,ntohs(server.sin_port),myhostid)) {
    close(sd);
    close(sock);
    return NULL;
  }
  if(putline(sock,"LIST")) { close(sd); close(sock); return NULL; }
  buffer=getline(sock,buffer);
  if(buffer==NULL) { close(sd); close(sock); return NULL; }
  if(!strncmp(buffer,"425",3)) goto resock;

  FD_ZERO(&listo);
  FD_SET(sd,&listo);
  tout.tv_sec=60;
#if TIMEVALORSPEC == 2
  tout.tv_nsec = 0;
#else    
  tout.tv_usec = 0;
#endif  
  if(select(sd+1,&listo,0,0,&tout)<0) {
    perror("SELECT");
    close(sd);
    return NULL;
  }
  l=0;
  if (!FD_ISSET(sd, &listo)) goto resock;
  sdr=accept(sd,(struct sockaddr *)0, (int *)0);
  { 
    int i=0;
    while(i<10&&!checkr(sdr)) sleep(1), i++, printf("voy %d\x0d",i), fflush(stdout);
  }
  buffer=getline(sdr,buffer);
  if(buffer==NULL) { close(sd); close(sock); return NULL; }
  rd=(void *)malloc(10*sizeof(void *));
  
  
  
/* Si, ya se, no se deben de poner gotos... pero aqui me gusto mucho jeje */

  if(strncmp(buffer,"total",5)) goto jmpnowhile;
  do {
  while((buffer=getlinels(sdr,buffer))!=NULL) {
    int c1,c2,c3;
    if(strlen(buffer)<3) break;
jmpnowhile:;  
#ifndef DEBUG
    printf("%lu archivos\x0d",++tfiles);
    fflush(stdout);
#endif
    if(rd!=NULL) 
      rd=(void *)realloc(rd,(l+10)*sizeof(void *));
    else
      rd=(void *)malloc((l+10)*sizeof(void));
    rd[l]=(struct regresadir *)malloc(sizeof(struct regresadir));
    for(c1=c2=0;c1<=8;c1++) {
      for(c3=0;c2<strlen(buffer)&&c3!=-1;c2++) 
        switch(buffer[c2]) {
          case ' ':
            if(c1==8) {
              datos[c1][c3]=buffer[c2];
              datos[c1][++c3]=0;
            } else {
              if(c1!=7)
                for(;c2<strlen(buffer)&&buffer[c2+1]==' ';c2++);
              datos[c1][c3]=0;
              c3=-1;
            }
            break;
          case 10:
          case 13:
            datos[c1][c3]=0;
            c3=-1;
            break;
          default:
            datos[c1][c3++]=buffer[c2];
            datos[c1][c3]=0;
        }
      }
    if(!strcmp(datos[5],"Jan")) rd[l]->mes=0; else       
    if(!strcmp(datos[5],"Feb")) rd[l]->mes=1; else       
    if(!strcmp(datos[5],"Mar")) rd[l]->mes=2; else       
    if(!strcmp(datos[5],"Apr")) rd[l]->mes=3; else       
    if(!strcmp(datos[5],"May")) rd[l]->mes=4; else       
    if(!strcmp(datos[5],"Jun")) rd[l]->mes=5; else       
    if(!strcmp(datos[5],"Jul")) rd[l]->mes=6; else       
    if(!strcmp(datos[5],"Aug")) rd[l]->mes=7; else       
    if(!strcmp(datos[5],"Sep")) rd[l]->mes=8; else       
    if(!strcmp(datos[5],"Oct")) rd[l]->mes=9; else       
    if(!strcmp(datos[5],"Nov")) rd[l]->mes=10; else       
    if(!strcmp(datos[5],"Dec")) rd[l]->mes=11;
    
    rd[l]->dia=atoi(datos[6]);
    
    if(datos[7][2]==':') {
      struct tm *ti;
      time_t tt=time(NULL);
      ti=gmtime(&tt);
      rd[l]->min=atoi((char *)&datos[7][3]);
      datos[7][2]=0;
      rd[l]->hora=atoi(datos[7]);

      if(rd[l]->mes<=ti->tm_mon&&rd[l]->dia<=ti->tm_mday&&
         rd[l]->hora<=ti->tm_hour&&rd[l]->min<=ti->tm_min)
        rd[l]->anio=ti->tm_year;
      else
        rd[l]->anio=ti->tm_year-1;
    } else {
      rd[l]->anio=(atoi(datos[7])%100);
      rd[l]->hora=rd[l]->min=0;
    }
    {
      struct tm ti;
      time_t tt;
      ti.tm_sec=0;
      ti.tm_min=rd[l]->min;
      ti.tm_hour=rd[l]->hora;
      ti.tm_mday=rd[l]->dia;
      ti.tm_mon=rd[l]->mes;
      ti.tm_year=rd[l]->anio;
      ti.tm_isdst=0;
      tt=mktime(&ti);
      rd[l]->tdate=tt;
    }
    rd[l]->tipo=buffer[0];
    strcpy(rd[l]->name,datos[8]);
    rd[l]->umode=rd[l]->gmode=rd[l]->wmode=0;  
    if(buffer[0]=='l') {
      char *llogic, *lfile;
      printf("Liga logica: %s\n",rd[l]->name);
      llogic=strstr(rd[l]->name,"-> ")+3;
      lfile=rd[l]->name;
      *(llogic-4)=0;
      printf("Archivo: [%s] Liga:[%s]\n",lfile,llogic);
      strcpy(rd[l]->link,llogic);
      strcpy(rd[l]->name,lfile);
      rd[l]->umode|=S_IFLNK;
    }
    if(buffer[1]!='-') rd[l]->umode|=S_IRUSR;
    if(buffer[2]!='-') rd[l]->umode|=S_IWUSR;
    if(buffer[3]!='-') rd[l]->umode|=S_IXUSR;

    if(buffer[4]!='-') rd[l]->umode|=S_IRGRP;
    if(buffer[5]!='-') rd[l]->umode|=S_IWGRP;
    if(buffer[6]!='-') rd[l]->umode|=S_IXGRP;

    if(buffer[7]!='-') rd[l]->umode|=S_IROTH;
    if(buffer[8]!='-') rd[l]->umode|=S_IWOTH;
    if(buffer[9]!='-') rd[l]->umode|=S_IXOTH;
    rd[l]->size=atol(datos[4]);
    l++;
    memset(buffer,0,sizeof(buffer));
  }
#ifdef DEBUG
    printf("checkr(sdr) reporto %d\n",checkr(sdr));
#endif
    if(checkr(sdr)==1) {
      char ttt[2];
      int rr;
#ifdef DEBUG
      printf("RECV %d ",recv(sdr,ttt,1,MSG_PEEK));
      printf("Byte es %d\n",ttt[0]);
#else
      rr=recv(sdr,ttt,1,MSG_PEEK);
#endif
      if(ttt[0]==0||ttt[0]==-1||ttt[0]<32||(unsigned char)ttt[0]>240||rr==0) break;
    }
  } while(checkr(sdr)>=0);
#ifndef DEBUG  
  printf("                                           \x0d");
  fflush(stdout);
#endif
  close(sdr);
  close(sd);
  rd[0]->n=l;
  buffer=getline(sock,buffer);
  if(buffer==NULL) { close(sd); close(sock); return NULL; }
finlistcmd:;
  while(checkr(sock)) {
    buffer=getline(sock,buffer);
    if(buffer==NULL) { close(sd); close(sock); return NULL; }
  }
  return rd;
}

int grabaarch(int sock, char *name, unsigned long size, struct regresadir rd)
{
  int sd,sdr,l,i,count,firstpacket,nocompress=0,tooslow=0;
  time_t tinit;
  unsigned long fs;
  struct sockaddr_in server;
  fd_set listo;
#if TIMEVALORSPEC == 2
  struct timespec tout;
#else
  struct timeval tout;
#endif  
  char *buffer=NULL;
  char tmpdat[BUFSIZE];
  unsigned long lpos, trbytes;
  struct stat statbuf;
  struct utimbuf ut;
  time_t paki;
  
grabainit:;
  
  strcpy(filename,name);
  filetime=rd.tdate;
  ut.actime=ut.modtime=rd.tdate;
  
  signal(SIGINT,(void *)interrupcionC);
  signal(SIGTERM,(void *)interrupcion);
  compressed=0;
  if(ignoredate) utime(name,&ut);
  if(stat(filename,&statbuf)!=-1) {
    if(statbuf.st_size>size) unlink(name);
    if(statbuf.st_size==size&&
       statbuf.st_mtime==rd.tdate) {
      printf("v\n"); fflush(stdout);
      signal(SIGINT,SIG_DFL);
      signal(SIGTERM,SIG_DFL);
      return 1;
    }
    printf("x\n"); fflush(stdout);
    if(statbuf.st_mtime!=rd.tdate) { 
      printf("Fechas diferentes: local: %s",ctime(&statbuf.st_mtime));
      printf("                   remot: %s",ctime(&rd.tdate));
      fflush(stdout);
      switch(EsElMismo(name,sock)) {
        case 0: unlink(name); break;
        case 1: return 0; 
        case 10: return 10;
      }
    }
    if(statbuf.st_size!=size&&ignoredate&&!ignoresize) 
      switch(EsElMismo(name,sock)) {
        case 0: unlink(name); break;
        case 1: return 0;
        case 10: return 10;
      }
  } else printf("x\n"); 
  fflush(stdout);
   



  
resock:;
  sd=socket(AF_INET,SOCK_STREAM,0);
  server.sin_family=AF_INET;
  server.sin_addr.s_addr=INADDR_ANY;
rebind:;
  srand(time(NULL)*rand());
  {
    unsigned int i=rand();
    while(i<1024||i>60000) i=rand();
    server.sin_port=htons(i);
  }
  if(bind(sd,(struct sockaddr *)&server, sizeof(server))) {
    perror("BIND");
    goto rebind;
  }
  l=sizeof(server);
  getsockname(sd,(struct sockaddr *)&server,&l);
  if(!mirror) printf("Esperando en puerto %u para comando RETR\n",ntohs(server.sin_port));
  listen(sd,1);
  if(sendportcmd(sock,ntohs(server.sin_port),myhostid)) {
    close(sd);
    close(sock);
    return 10;
  }


  if((filehand=fopen(name,"r+b"))==NULL) 
    if((filehand=fopen(name,"w+b"))==NULL) {
      perror("FOPEN");
      printf("Archivo '%s'\n",name);
      signal(SIGINT,SIG_DFL);
      signal(SIGTERM,SIG_DFL);
      return 0;
    }
  fseek(filehand,0,SEEK_END);
  fs=ftell(filehand);
  if(putline(sock,"TYPE I")) goto fingetfiles;
  do {
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
  } while(strncmp(buffer,"200",3));
  lpos=0;
  if(fs>10) {
    fs-=10;
    fseek(filehand,fs,SEEK_SET);
    sprintf(tmpdat,"REST %lu",fs);
    if(putline(sock,tmpdat)) goto fingetfiles;
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
    puts(buffer);
    lpos=ftell(filehand);
    if(strncmp(buffer,"350",3)) {
      fseek(filehand,0,SEEK_SET);
      printf("Servidor no soporta comando REST\n"); fflush(stdout);
      lpos=0;
    } else {
      printf("Continuando desde el byte %lu\n",fs); fflush(stdout);
    }
  } else fseek(filehand,0,SEEK_SET);



  if((gzip==1||gzip==2)&&lpos==0&&size>128&&!nocompress&&
     strcmp((char *)&name[strlen(name)-2],".z")&&
     strcmp((char *)&name[strlen(name)-4],".Z")&&
     strcmp((char *)&name[strlen(name)-3],".gz")&&
     strcmp((char *)&name[strlen(name)-4],".tgz")&&
     strcmp((char *)&name[strlen(name)-4],".rpm")&&
     strcmp((char *)&name[strlen(name)-4],".zip")&&
     strcmp((char *)&name[strlen(name)-4],".arj")&&
     strcmp((char *)&name[strlen(name)-4],".lzh")&&
     strcmp((char *)&name[strlen(name)-4],".mpg")&&
     strcmp((char *)&name[strlen(name)-4],".arc")&&
     strcmp((char *)&name[strlen(name)-4],".zoo")&&
     strcmp((char *)&name[strlen(name)-4],".gif")&&
     strcmp((char *)&name[strlen(name)-4],".jpg")) {
    sprintf(tmpdat,"RETR %s.gz",name);
    if(putline(sock,tmpdat)) goto fingetfiles;
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
    if(!strncmp(buffer,"425",3)||!strncmp(buffer,"550",3)) {
      if(gzip==1) {
        gzip=0;
        printf("Servidor no soporta compresion de datos\n"); fflush(stdout);
      } else {
        printf("Error al solicitar compresion de datos, reintento\n");
        fflush(stdout);
      }
      fclose(filehand);
      close(sd);
      goto resock;
    } 
    if(!mirror) printf("Compresion de datos soportada\n");
    compressed=1;
    gzip=2;
  } else {
    sprintf(tmpdat,"RETR %s",name);
    if(putline(sock,tmpdat)) goto fingetfiles;
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
    if(!strncmp(buffer,"425",3)||!strncmp(buffer,"550",3)) { 
      close(sd); fclose(filehand); 
      if(strstr(buffer,"denied")!=NULL) {
        printf("Permiso denegado\n");
        return 15; 
      }
      goto resock; 
    }
    compressed=0;
  }

  FD_ZERO(&listo);
  FD_SET(sd,&listo);
  tout.tv_sec=60;
#if TIMEVALORSPEC == 2
  tout.tv_nsec = 0;
#else    
  tout.tv_usec = 0;
#endif  
  if(select(sd+1,&listo,0,0,&tout)<0) {
    perror("SELECT");
    close(sd);
    fclose(filehand);
    signal(SIGINT,SIG_DFL);
    signal(SIGTERM,SIG_DFL);
    return 0;
  }
  if (!FD_ISSET(sd, &listo)) { fclose(filehand); close(sd); goto resock; }
  sdr=accept(sd,(struct sockaddr *)0, (int *)0);
    
  tinit=time(NULL);
  trbytes=0;
  paki=time(NULL);
  for(count=0,firstpacket=1;lpos<(size+(size>1024?1024:size));count++) {
    if(count>120) {
      sleep(1);
      cmdABORT(sock);
      sleep(5);
      close(sdr);
      close(sd);
      while(checkr(sock)) {
        buffer=getline(sock,buffer);
        if(buffer==NULL) goto fingetfiles;
      }
    }    
    if(priochg) {
      priochg=0;
      printf("\nCambio de prioridad a %d%% \n",priority);
      signal(SIGINT,(void *)interrupcionC);
      signal(SIGTERM,(void *)interrupcion);
    }  
    switch(firstpacket?1:checkr(sdr)) {
      case 1: 
        firstpacket=0;
        count=0;
        if(tooslow) {
          if((l=recv(sdr,tmpdat,1,0))<=0&&size!=0) break;
          tooslow++;
          if(tooslow>64) tooslow=0;
        } else {
          if(priority<100) {
            if((l=recv(sdr,tmpdat,BUFSIZE/(100-priority),0))<=0&&size!=0) break;
          } else {
            if((l=recv(sdr,tmpdat,BUFSIZE,0))<=0&&size!=0) break;
          }
        }
        fwrite(tmpdat,1,l,filehand);
        utime(name,&ut);
        lpos+=l;
        trbytes+=l;
        if(priority<100) {
          if(!tooslow) usleep(5000000/priority);
        }
        if((time(NULL)-paki)>10) tooslow=1;
        paki=time(NULL);
        break;
      case -2: goto finfor;
      case -1:
      {
        char tmpfile[300],tmpcmd[400];
        if(priochg) {
          priochg=0;
          printf("\nCambio de prioridad a %d%% \n",priority);
          signal(SIGINT,(void *)interrupcionC);
          signal(SIGTERM,(void *)interrupcion);
          break;
        }  
        fclose(filehand);
        if(compressed==1&&(gzip==1||gzip==2)) {
          sprintf(tmpfile,"%s.gz",filename);
          if(unlink(tmpfile)==-1) printf("No pude borrar temporal comprimido\n");
          printf("No se puede continuar un archivo comprimido... descomprimiendo\n");
          rename(filename,tmpfile);
          sprintf(tmpcmd,"gzip -d -c \x22%s\x22 > \x22%s\x22",tmpfile,filename);
          system(tmpcmd);
          if(unlink(tmpfile)==-1) printf("No pude borrar temporal comprimido\n");
        }
        sleep(1);
        cmdABORT(sock);
        sleep(5);
        close(sdr);
        close(sd);
        uname(name,&ut);
        if(!strncmp(buffer,"426",3)) {
          while(checkr(sock)) {
            buffer=getline(sock,buffer);
            if(buffer==NULL) { close(sd); close(sock); return 10; }
          }
          strcpy(name,filename);
          goto grabainit;
        }
        while(checkr(sock)) {
          buffer=getline(sock,buffer);
          if(buffer==NULL) { close(sd); close(sock); return 10; }
        }
        goto resock;
      }
      default: sleep(1);
    }
    if(!mirror) {
      printf("%s = (%lu) [%s] %lu       ",name,size,aprox(size,lpos,trbytes,tinit),lpos);
      putchar(13);
      if(lpos>=size) break;
    }
    fflush(stdout);
  }
finfor:;  

  if(compressed==1&&(gzip==1||gzip==2)) {
    if(lpos==0)
      printf("%s = (%lu) [%s] %lu  Compresion %u:1     ",name,size,aprox(size,size,trbytes,tinit),size,size);
    else
      printf("%s = (%lu) [%s] %lu  Compresion %u:1     ",name,size,aprox(size,size,trbytes,tinit),size,size/lpos);
    putchar(13);
  }
  printf("\n");
  close(sdr);
  close(sd);
  fclose(filehand);
  fflush(stdout);
  if((gzip==1||gzip==2)&&compressed==1) {
    if(!mirror) printf("Descomprimiendo archivo\n");
    sprintf(tmpdat,"%s.gz",name);
    unlink(tmpdat);
    rename(name,tmpdat);
    sprintf(tmpdat,"gzip -d \x22%s.gz\x22 1> /dev/null 2> /dev/null",name);
#ifdef DEBUG    
    printf("comando: [%s]\n",tmpdat);
#endif    
    if(system(tmpdat)==256) {
      if(!mirror) putchar(13);
      printf("Error en decompresion gzip [%s]\n",filename);
      fflush(stdout);
      nocompress=1;
      sprintf(tmpdat,"%s.gz",name);
      if(unlink(tmpdat)==-1) 
        printf("No pude borrar temporal comprimido\n");
      goto resock;
    }
    sprintf(tmpdat,"%s.gz",name);
    if(unlink(tmpdat)==-1); // printf("No pude borrar temporal comprimido\n");
  }
  utime(name,&ut);
  if(stat(filename,&statbuf)!=-1) {
    if(statbuf.st_mtime!=rd.tdate) {
      printf("Err en fecha\n");
      utime(name,&ut);
    }
  }

  sleep(1);
  while(checkr(sock)) {
    buffer=getline(sock,buffer);
    if(buffer==NULL) { close(sd); close(sock); return 10; }
    if(!strncmp(buffer,"226",3)) break;
  }
  if(strncmp(buffer,"226",3)) 
    printf("Posible error en transmision \n%s\n",buffer);
  fflush(stdout);
  signal(SIGINT,SIG_DFL);
  signal(SIGTERM,SIG_DFL);
  if(buffer==NULL) { close(sd); close(sock); return 10; }
  return 0;
  
fingetfiles:;
  fclose(filehand); 
  close(sd); 
  close(sock); 
  if((gzip==1||gzip==2)&&compressed==1) {
    sprintf(tmpdat,"%s.gz",name);
    if(unlink(tmpdat)==-1) printf("No pude borrar temporal comprimido\n");
  }
  utime(filename,&ut);
  signal(SIGINT,SIG_DFL);
  signal(SIGTERM,SIG_DFL);
  return 10; 
}

int sendportcmd(int sock, int port, unsigned long addr)
{
  char cmd[256];
  char *buffer=NULL;
  unsigned char addrC[4], portC[2];
  memcpy(addrC,(char *)&addr,4);
  memcpy(portC,(char *)&port,2);

  sprintf(cmd,"PORT %d,%d,%d,%d,%d,%d",addrC[0],addrC[1],addrC[2],addrC[3],
                                       portC[1],portC[0]);
  if(putline(sock,cmd)) { close(sock); return 1; }
  do {
  do {
    buffer=getline(sock,buffer);
    if(buffer==NULL) { close(sock); return 1; }
  } while(strncmp(buffer,"200",3)&&strncmp(buffer,"500",3));
  } while(!strncmp(buffer,"500 No comm",11));
  if(!strncmp(buffer,"500",3)) {
    printf("PORT: %s\n%s\nIMPOSIBLE CONTINUAR\n\n",cmd,buffer);
    return 1;
  }
  return 0;
}
  
int cambiadir(int sock, char *path)
{
  char *buffer=NULL;
  char tmpbuf[8192];
  sprintf(tmpbuf,"CWD %s",path);
  while(checkr(sock)) {
    buffer=getline(sock,buffer);
    if(buffer==NULL) { close(sock); return 1; }
  }
  if(putline(sock,tmpbuf)) { close(sock); return 1; }
  do {
    buffer=getline(sock,buffer);
    fflush(stdout);
    if(buffer==NULL) { close(sock); return 1; }
  } while(strncmp(buffer,"250",3)&&strncmp(buffer,"550",3));
  if(!strncmp(buffer,"550",3)) {
    printf("Error en el directorio\n");
    return 1;
  }
  return 0;
}


char *dimedir(int sock)
{
  char *buffer=NULL;
  char tmpbuf[1024];
  int i,j;
  if(putline(sock,"PWD")) { close(sock); return NULL; } 
  do {
    buffer=getline(sock,buffer);
    if(buffer==NULL) { close(sock); return NULL; }
  } while(strncmp(buffer,"257",3));
  for(i=0;i<strlen(buffer);i++) if(buffer[i]=='"') break;
  i++;
  for(j=i;j<strlen(buffer);j++) if(buffer[j]=='"') buffer[j]=0;
  strcpy(tmpbuf,(char *)&buffer[i]);
  strcpy(buffer,tmpbuf);
  printf("CWD: [%s]\n",buffer);
  sleep(1);
  return buffer;
}

int loginftp(int sock)
{  
  char *buffer=NULL;
  char tmpbuf[1024];
  printf("Registrando usuario [%s] y password (%d%% de prioridad)",USUARIO,priority);
  fflush(stdout);
  sleep(2);
//  puts("1");
  while(!checkr(sock)) sleep(1);
  while(checkr(sock)) {
    buffer=getline(sock,buffer);
    if(buffer==NULL) { close(sock); return 1; }
  }
//  puts("2");
  if(buffer==NULL) { close(sock); return 1; }
//  puts("3");
  if(!strncmp(buffer,"421",3)) {
    printf("\nEl servidor esta lleno, reintentando\n");
    close(sock);
    return 1;
  }
//  puts("4");
  if(strncmp(buffer,"220",3)) {
    printf("\nRespuesta desconocida del servidor\n");
    close(sock);
    return 1;
  }
//  puts("5");
  putchar('.'); fflush(stdout);
  sprintf(tmpbuf,"USER %s",USUARIO);
  if(putline(sock,tmpbuf)) { close(sock); return 1; }
  putchar('.'); fflush(stdout);
  buffer=getline(sock,buffer);
  if(buffer==NULL) { close(sock); return 1; }
  if(!strncmp(buffer,"530",3)) {
    printf("\nEl usuario especificado no tiene derecho de entrada por ftp\n");
    close(sock);
    exit(0);
  }
  if(strncmp(buffer,"331",3)&&strncmp(buffer,"220",3)&&strncmp(buffer,"230",3)) {
    printf("\nRespuesta a comando USER desconocida\n");
    close(sock);
    return 1;
  }
  if(!strncmp(buffer,"230",3)) {
    while(checkr(sock)) buffer=getline(sock,buffer);
    goto nonpass;
  }
  while(checkr(sock)) {
    if(!strncmp(buffer,"230",3)) {
      while(checkr(sock)) buffer=getline(sock,buffer);
      goto nonpass;
    }
    buffer=getline(sock,buffer);
  }
  putchar('.'); fflush(stdout);
  sprintf(tmpbuf,"PASS %s",PASSWORD);
  if(putline(sock,tmpbuf)) { close(sock); return 1; }
  do {
    buffer=getline(sock,buffer);
nonpass:;
    putchar('.'); fflush(stdout);
    if(buffer==NULL) { close(sock); return 1; }
    if(!strncmp(buffer,"530",3)) {
      printf("\nError: Usuario o password incorrecto(s)\n");
      exit(6);
    }
  } while(strncmp(buffer,"230",3));
  printf("Registrados\n");
  fflush(stdout);
  return 0;
}  
  
  
void sttybbs(sflag)
int sflag;
{
  struct termio live;
  if(sflag==2) {
    ioctl(0,TCSETA,&stty0);
    return;
  }
  if(sflag==3) {
    ioctl(0,TCGETA,&stty0);
    return;
  }
  ioctl(0,TCGETA,&live);

/*  live.c_iflag &=~(INLCR | IGNCR | ICRNL);
  live.c_iflag |= IXOFF | IXON | IXANY;
  live.c_oflag &= ~(ONLCR | OCRNL);
  live.c_lflag &= ~(ISIG | ICANON | ECHO);
  live.c_cc[VMIN] = 1;
  live.c_cc[VTIME] = 0;*/



  /*VINTR,VQUIT,VERASE,VKILL,VEOF,VEOL,VEOL2,VMIN,VTIME*/
  live.c_iflag=IXOFF|IXON|IXANY;
  live.c_oflag=OPOST|ONLCR;
  live.c_lflag=NOFLSH;
  if (sflag==1) live.c_lflag=ISIG|NOFLSH;
  live.c_line=0;
  live.c_cc[VMIN]=0;
  live.c_cc[VTIME]=0;
  ioctl(0,TCSETA,&live);
/*  ioctl(0,TCFLSH,2);*/
  return;
}
  
  
int inkey()
{
  int a;
  a=getchar();
  if (a==127) a=8;
  if (a==10) a=0; 
  if(a==-1 || a==27) a=0;
  if(a==9) a=0;
  if(a<32 && a!=13 && a!=8) a=0;
  return(a);
}


char *aprox(unsigned long size, unsigned long pos, unsigned long trbytes, time_t tinit)
{
  long bps,spf;
  int h,m,s;
  char *regr=(char *)malloc(20);
  sprintf(regr,"99:99:99");
  if(time(NULL)==tinit) return regr;
  bps=trbytes/(time(NULL)-tinit);
  if(bps==0) return regr;
  spf=(size-pos)/bps;
  h=spf/3600;
  spf-=(h*3600);
  m=spf/60;
  spf-=(m*60);
  s=spf;
  if(bps>8192) {
    sprintf(regr,"%02u:%02u:%02u %luKbps",h,m,s,bps/1024);
  } else {
    sprintf(regr,"%02u:%02u:%02u %lubps",h,m,s,bps);
  }
  return regr;
}

int checkgzip(void)
{
  FILE *fp;
  char tmpfile[256],tmpcmd[300];
  printf("Checando si esta maquina soporta compresion gzip\n");
  sprintf(tmpfile,"/tmp/%u.tmp~",getpid());
  if((fp=fopen(tmpfile,"wb"))==NULL) {
    printf("No pude terminar de checarlo, desactivo la compresion\n");
    gzip=0;
    return 0;
  }
  fprintf(fp,"Esta es una linea de compresion, probando a ver si se comprime\n");
  fclose(fp);
  printf("Compresion: ");
  sprintf(tmpcmd,"gzip %s > /dev/null",tmpfile);
  if(system(tmpcmd)==0) printf("OK\n"); else { gzip=0; printf("Fallo\n"); return 0; }
  printf("Decompresion: ");
  sprintf(tmpcmd,"gzip -d \x22%s.gz\x22 > /dev/null",tmpfile);
  if(system(tmpcmd)==0) printf("OK\n"); else { gzip=0; printf("Fallo\n"); return 0; }
  unlink(tmpfile);
  return 1;
}

void alarma(void) {}

struct regresadir *checkmdtm(struct regresadir *rd, int sock)
{
  char tmpdat[256];
  char *buffer=NULL;
  sprintf(tmpdat,"MDTM %s",rd->name);
  if(putline(sock,tmpdat)) { close(sock); return NULL; }
  buffer=getline(sock,buffer);
  if(buffer==NULL) { close(sock); return NULL; }
  if(strncmp(buffer,"213",3)) {
    printf("\n<MDTM: %s>\n",buffer);
    printf("No puedo obtener las fechas originales, la proxima vez para\n"
           "continuar la transferencias corre el programa con -ignoredate\n");
    return rd;
  }
  bzero(tmpdat,sizeof(tmpdat));
  strncpy(tmpdat,(buffer+4),4);
  rd->anio=atoi(tmpdat);
  bzero(tmpdat,sizeof(tmpdat));
  strncpy(tmpdat,(buffer+8),2);
  rd->mes=atoi(tmpdat);
  bzero(tmpdat,sizeof(tmpdat));
  strncpy(tmpdat,(buffer+10),2);
  rd->dia=atoi(tmpdat);
  bzero(tmpdat,sizeof(tmpdat));
  strncpy(tmpdat,(buffer+12),2);
  rd->hora=atoi(tmpdat);
  bzero(tmpdat,sizeof(tmpdat));
  strncpy(tmpdat,(buffer+14),2);
  rd->min=atoi(tmpdat);
  return rd;
}


int erasefile(char *arch, int sock)
{
  char tmpdat[256];
  char *buffer=NULL;
  printf("Eliminando archivo [%s] ",arch); fflush(stdout);
  sprintf(tmpdat,"DELE %s",arch);
  if(putline(sock,tmpdat)) { close(sock); return 2; }
  buffer=getline(sock,buffer);
  if(buffer==NULL) { close(sock); return 2; }
  if(strncmp(buffer,"250",3)) {
    printf("\n<DELE: %s>\n",buffer);
    return 1;
  }
  printf("v\n");
  return 0;
}

int EsElMismo(char *name, int sock)
{
  int sd,sdr,i;
  struct sockaddr_in server;
  int l,p;
  unsigned long fs,lpos;
  char *buffer=NULL, tmpdat[CRCSIZE+256], buftmp[CRCSIZE+256];
  fd_set listo;
#if TIMEVALORSPEC == 2
  struct timespec tout;
#else
  struct timeval tout;
#endif  
  
resock:;
  if((sd=socket(AF_INET,SOCK_STREAM,0))==-1) {
    printf("Socket error\n");
    return 0;
  }
  server.sin_family=AF_INET;
  server.sin_addr.s_addr=INADDR_ANY;
rebind:;
  srand(time(NULL)*rand());
  {
    unsigned int i=rand();
    while(i<1024||i>60000) i=rand();
    server.sin_port=htons(i);
  }
  if(bind(sd,(struct sockaddr *)&server, sizeof(server))) {
    perror("BIND");
    goto rebind;
  }
  l=sizeof(server);
  getsockname(sd,(struct sockaddr *)&server,&l);
  if(!mirror) printf("CRC1? "), fflush(stdout);
  listen(sd,1);
  if(sendportcmd(sock,ntohs(server.sin_port),myhostid)) {
    close(sd);
    close(sock);
    return 10;
  }
  if((filehand=fopen(name,"r+b"))==NULL) {
    close(sd);
    printf("x\n");
    return 0;
  }
  fread(buftmp,1,CRCSIZE,filehand); buftmp[CRCSIZE]=0;
  if(putline(sock,"TYPE I")) goto fingetfiles;
  do {
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
  } while(strncmp(buffer,"200",3));
  fseek(filehand,0,SEEK_END);
  fs=ftell(filehand);
  if(fs>CRCSIZE) fseek(filehand,fs-CRCSIZE,SEEK_SET);
  lpos=0;
  sprintf(tmpdat,"REST %lu",0);
  if(putline(sock,tmpdat)) goto fingetfiles;
  buffer=getline(sock,buffer);
  if(buffer==NULL) goto fingetfiles;
  lpos=ftell(filehand);
  if(strncmp(buffer,"350",3)) {
    printf("x\n");
    fclose(filehand);
    close(sd);
    return 0;
  }
  sprintf(tmpdat,"RETR %s",name);
  if(putline(sock,tmpdat)) goto fingetfiles;
  do {
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
  } while(strncmp(buffer,"150",3)&&strncmp(buffer,"425",3)&&strncmp(buffer,"550",3));
  if(!strncmp(buffer,"425",3)||!strncmp(buffer,"550",3)) {
    printf("x\n");
    close(sd);
    fclose(filehand);
    return 0;
  } 
  FD_ZERO(&listo);
  FD_SET(sd,&listo);
  tout.tv_sec=60;
#if TIMEVALORSPEC == 2
  tout.tv_nsec = 0;
#else    
  tout.tv_usec = 0;
#endif  
  if(select(sd+1,&listo,0,0,&tout)<0) {
    perror("SELECT");
    close(sd);
    fclose(filehand);
    signal(SIGINT,SIG_DFL);
    signal(SIGTERM,SIG_DFL);
    return 0;
  }
  if (!FD_ISSET(sd, &listo)) { fclose(filehand); close(sd); goto resock; }
  sdr=accept(sd,(struct sockaddr *)0, (int *)0);
  if(sdr==-1) {
    printf("Error en accept\n");
    return 0;
  }
  close(sd);
  for(p=0;p<CRCSIZE;p++) {
    l=read(sdr,(char *)&tmpdat[p],1); /*recv(sdr,(char *)&tmpdat[p],1,0);*/
    if(l<=0) return 0;
    tmpdat[p+1]=0;
    if(!(p%96)&&p&&l) {
      putchar('.');
      fflush(stdout);
    }
  } 
  cmdABORT(sock);
  do {
    while(checkr(sock)) {
      buffer=getline(sock,buffer);
      if(buffer==NULL) goto fingetfiles;
      if(strncmp(buffer,"426",3)&&strncmp(buffer,"225",3)&&strncmp(buffer,"226",3))
        goto fingetfiles;
    }
  } while(strncmp(buffer,"22",2));
  close(sdr);
  if(!memcmp(tmpdat,buftmp,CRCSIZE)) {
    /*-------------------------------------------------------------------*/
resock1:;
    sd=socket(AF_INET,SOCK_STREAM,0);
    server.sin_family=AF_INET;
    server.sin_addr.s_addr=INADDR_ANY;
rebind1:;
    srand(time(NULL)*rand());
    {
      unsigned int i=rand();
      while(i<1024||i>60000) i=rand();
      server.sin_port=htons(i);
    }
    if(bind(sd,(struct sockaddr *)&server, sizeof(server))) {
      perror("BIND");
      goto rebind1;
    }
    l=sizeof(server);
    getsockname(sd,(struct sockaddr *)&server,&l);
    if(!mirror) printf("CRC2?"),fflush(stdout);
    listen(sd,1);
    if(sendportcmd(sock,ntohs(server.sin_port),myhostid)) {
      close(sd);
      close(sock);
      return 10;
    }
    fs=ftell(filehand);
    fread(buftmp,1,CRCSIZE,filehand); buftmp[CRCSIZE]=0;
    if(putline(sock,"TYPE I")) goto fingetfiles;
    do {
      buffer=getline(sock,buffer);
      if(buffer==NULL) goto fingetfiles;
    } while(strncmp(buffer,"200",3));
    lpos=0;
    sprintf(tmpdat,"REST %lu",fs);
    if(putline(sock,tmpdat)) goto fingetfiles;
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
    lpos=ftell(filehand);
    if(strncmp(buffer,"350",3)) {
      printf("x\n");
      fclose(filehand);
      close(sd);
      return 0;
    }
    sprintf(tmpdat,"RETR %s",name);
    if(putline(sock,tmpdat)) goto fingetfiles;
    buffer=getline(sock,buffer);
    if(buffer==NULL) goto fingetfiles;
    if(!strncmp(buffer,"425",3)||!strncmp(buffer,"550",3)||!strncmp(buffer,"451",3)) {
      printf("x\n");
      fclose(filehand);
      close(sd);
      return 0;
    } 
    FD_ZERO(&listo);
    FD_SET(sd,&listo);
    tout.tv_sec=60;
#if TIMEVALORSPEC == 2
    tout.tv_nsec = 0;
#else    
    tout.tv_usec = 0;
#endif  
    if(select(sd+1,&listo,0,0,&tout)<0) {
      perror("SELECT");
      close(sd);
      fclose(filehand);
      signal(SIGINT,SIG_DFL);
      signal(SIGTERM,SIG_DFL);
      return 0;
    }
    if (!FD_ISSET(sd, &listo)) { fclose(filehand); close(sd); goto resock; }
    sdr=accept(sd,(struct sockaddr *)0, (int *)0);
    for(p=0;p<CRCSIZE;p++) {
      l=read(sdr,(char *)&tmpdat[p],1);
      if(l<=0) return 0;
      tmpdat[p+1]=0;
      if(!(p%96)&&p&&l) {
        putchar('.');
        fflush(stdout);
      }
    } 
    cmdABORT(sock);
    for(i=0;i<10;i++) {
      while(checkr(sock)) {
        buffer=getline(sock,buffer);
        if(buffer==NULL) goto fingetfiles;
        if(strncmp(buffer,"426",3)&&strncmp(buffer,"225",3)&&strncmp(buffer,"226",3))
          goto fingetfiles;
        else {
          if(!strncmp(buffer,"226",3)) i=10;
        }
      }
      sleep(1);
    } 
    close(sdr);
    sleep(1);
    while(checkr(sock)) {
      buffer=getline(sock,buffer);
      if(buffer==NULL) goto fingetfiles;
    }
    fclose(filehand);
    if(!memcmp(tmpdat,buftmp,CRCSIZE)) { printf(" ok\n"); return 1; }
  }
exitif:;
  close(sdr);
  close(sd);
  fclose(filehand);
  printf("x\n");
  return 0;
  
  
fingetfiles:;
  close(sdr);
  close(sd);
  fclose(filehand);
  printf("x CONN CLOSED\n");
  return 10;
}

int checkexclude(char *n)
{
  int i;
  if(exclude==NULL||n==NULL) return 0;
  for(i=0;exclude[i]!=NULL&&i<maxexclude;i++) {
/*    printf("n={%s} e=[%s]\n",n,exclude[i]);*/
    if(!strcmp(n,exclude[i])) return 1;
    if(checkwildcards(exclude[i],n)==1) return 1;
  }
  return 0;
}

int checkdownload(char *n)
{
  int i;
  if(download==NULL||n==NULL) return 0;
  for(i=0;download[i]!=NULL&&i<maxdownload;i++) {
/*    printf("n={%s} e=[%s]\n",n,download[i]);*/
    if(!strcmp(n,download[i])) return 1;
    if(checkwildcards(download[i],n)==1) return 1;
  }
  return 0;
}

int checkwildcards(char *w, char *n)
{
  int i,j,c;
  char tmpcmd[256], tmpdir[256], tmpfile[256], myfile[256];
  FILE *fp;
  struct stat st;
  if(!strcmp(n,"..") || !strcmp(n,".")) return 0;
  sprintf(tmpdir,"/tmp/%u.dir",getpid());
  sprintf(tmpfile,"/tmp/%u.file",getpid());
  sprintf(myfile,"%s/%s",tmpdir,n);
  sprintf(tmpcmd,"ls %s/%s 2> /dev/null > %s",tmpdir,w,tmpfile);
  mkdir(tmpdir,00777);
  if((fp=fopen(myfile,"wb"))==NULL) {
    printf("Error en creacion de wildcard %s %s\n",w,n); 
  }
  fclose(fp);
  system(tmpcmd);
  unlink(myfile);
  rmdir(tmpdir);
  if(stat(tmpfile,&st)==-1) return 0;
  unlink(tmpfile);
  if(st.st_size==0) return 0;
  return 1;
}